Index: CKEditor/trunk/_source/core/config.js
===================================================================
--- CKEditor/trunk/_source/core/config.js	(revision 3646)
+++ CKEditor/trunk/_source/core/config.js	(revision 3649)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -202,5 +202,5 @@
 	 * config.skin = 'myskin,/customstuff/myskin/';
 	 */
-	skin : 'v2',
+	skin : 'kama',
 
 	/**
Index: CKEditor/trunk/_source/core/env.js
===================================================================
--- CKEditor/trunk/_source/core/env.js	(revision 3646)
+++ CKEditor/trunk/_source/core/env.js	(revision 3649)
@@ -195,8 +195,13 @@
 				'unknown' );
 
+		if ( env.quirks )
+			env.cssClass += ' cke_browser_quirks';
+
 		if ( env.ie )
 		{
-			if ( env.version < 7 )
-				env.cssClass += ' cke_browser_ie6';
+			env.cssClass += ' cke_browser_ie' + (
+				env.version < 7 ? '6' :
+				env.version >= 8 ? '8' :
+				'7' );
 
 			if ( env.quirks )
Index: CKEditor/trunk/_source/core/skins.js
===================================================================
--- CKEditor/trunk/_source/core/skins.js	(revision 3646)
+++ CKEditor/trunk/_source/core/skins.js	(revision 3649)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -164,4 +164,11 @@
 						{
 							loadedPart( skinName, skinPart, callback );
+							
+							// Get the skin definition.
+							var skinDefinition = loaded[ skinName ];
+
+							// Trigger init function if any.
+							if ( skinDefinition.init )
+								skinDefinition.init( editor );
 						});
 			}
Index: CKEditor/trunk/_source/plugins/button/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/button/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/button/plugin.js	(revision 3649)
@@ -58,4 +58,6 @@
 CKEDITOR.ui.button.prototype =
 {
+	canGroup : true,
+
 	/**
 	 * Renders the button.
Index: CKEditor/trunk/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 3649)
@@ -1026,4 +1026,5 @@
 						type : 'button',
 						label : editor.lang.common.ok,
+						'class' : 'cke_dialog_ui_button_ok',
 						onClick : function( evt )
 						{
@@ -1059,4 +1060,5 @@
 						type : 'button',
 						label : editor.lang.common.cancel,
+						'class' : 'cke_dialog_ui_button_cancel',
 						onClick : function( evt )
 						{
Index: CKEditor/trunk/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 3649)
@@ -479,5 +479,6 @@
 						href : 'javascript:void(0)',
 						title : elementDefinition.label,
-						hidefocus : 'true'
+						hidefocus : 'true',
+						'class' : elementDefinition['class']
 					},
 					'<span class="cke_dialog_ui_button">' +
Index: CKEditor/trunk/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 3649)
@@ -184,4 +184,7 @@
 
 								target.setStyle( 'height', height + 'px' );
+
+								// Fix IE < 8 visibility. 
+								panel._.currentBlock.element.setStyle( 'display', 'none' ).removeStyle( 'display' );
 							}
 
Index: CKEditor/trunk/_source/plugins/maximize/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/maximize/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/maximize/plugin.js	(revision 3649)
@@ -84,5 +84,5 @@
 		{
 			var viewPaneSize = mainWindow.getViewPaneSize();
-			editor.resize( viewPaneSize.width, viewPaneSize.height );
+			editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
 		};
 	}
@@ -178,5 +178,5 @@
 									top : '0px'
 								} );
-							editor.resize( viewPaneSize.width, viewPaneSize.height );
+							editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
 
 							// Still not top left? Fix it. (Bug #174)
Index: CKEditor/trunk/_source/plugins/menu/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 3649)
@@ -322,8 +322,8 @@
 					' onclick="CKEDITOR.tools.callFunction(', menu._.itemClickFn, ',', index, '); return false;"' +
 					'>' +
-						'<span class="cke_icon"' +
-							( this.icon ? ' style="background-image:url(' + CKEDITOR.getUrl( this.icon ) + ');background-position:0 ' + offset + 'px;"'
+						'<span class="cke_icon_wrapper"><span class="cke_icon"' +
+							( this.icon ? ' style="background-image:url(' + CKEDITOR.getUrl( this.icon ) + ');background-position:0 ' + offset + 'px;"></span>'
 							: '' ) +
-							'></span>' +
+							'></span></span>' +
 						'<span class="cke_label">' );
 
Index: CKEditor/trunk/_source/plugins/richcombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 3649)
@@ -112,5 +112,5 @@
 						_.list.unmarkAll();
 
-					_.panel.showBlock( this.id, new CKEDITOR.dom.element( $element ).getChild( [0, 1] ), 4 );
+					_.panel.showBlock( this.id, new CKEDITOR.dom.element( $element ), 4 );
 				},
 				this );
@@ -189,5 +189,6 @@
 						'<span>' +
 							'<span class="cke_accessibility">' + ( this.voiceLabel ? this.voiceLabel + ' ' : '' ) + '</span>' +
-							'<span id="' + id + '_text" class="cke_text">&nbsp;</span></span>' +
+							'<span id="' + id + '_text" class="cke_text cke_inline_label">' + this.label + '</span>' +
+						'</span>' +
 						'<span class=cke_openbutton></span>' +
 					'</a>' +
@@ -282,4 +283,12 @@
 
 			var textElement = this.document.getById( 'cke_' + this.id + '_text' );
+
+			if ( !value )
+			{
+				text = this.label;
+				textElement.addClass( 'cke_inline_label' );
+			}
+			else
+				textElement.removeClass( 'cke_inline_label' );
 			textElement.setHtml( typeof text != 'undefined' ? text : value );
 		},
Index: CKEditor/trunk/_source/plugins/sourcearea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 3649)
@@ -51,23 +51,6 @@
 							if ( CKEDITOR.env.ie )
 							{
-								if ( CKEDITOR.env.quirks || CKEDITOR.env.version < 8 )
+								if ( !CKEDITOR.env.ie8Compat )
 								{
-									// In IE, we must use absolute positioning to
-									// have the textarea filling the full content
-									// space height.
-									holderElement.setStyle( 'position', 'relative' );
-									styles[ 'position' ] = 'absolute';
-								}
-
-								if ( !CKEDITOR.env.quirks || CKEDITOR.env.version < 7 )
-								{
-									function getHolderRect()
-									{
-										return {
-											height : holderElement.$.clientHeight + 'px',
-											width : holderElement.$.clientWidth + 'px'
-										};
-									}
-
 									onResize = function()
 										{
@@ -75,10 +58,10 @@
 											// so hide it just for a moment.
 											textarea.hide();
-											textarea.setStyles( getHolderRect() );
+											textarea.setStyle( 'height', holderElement.$.clientHeight + 'px' );
 											// When we have proper holder size, show textarea again.
 											textarea.show();
 										};
-									styles = CKEDITOR.tools.extend( styles, getHolderRect(), true );
 									editor.on( 'resize', onResize );
+									styles.height = holderElement.$.clientHeight + 'px';
 								}
 							}
Index: CKEditor/trunk/_source/plugins/table/dialogs/table.js
===================================================================
--- CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 3649)
@@ -24,5 +24,5 @@
 			title : editor.lang.table.title,
 			minWidth : 250,
-			minHeight : 280,
+			minHeight : CKEDITOR.env.ie ? 295 : 280,
 			onShow : function()
 			{
Index: CKEditor/trunk/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 3649)
@@ -114,5 +114,6 @@
 
 						var output = [ '<div class="cke_toolbox"' ],
-							expanded =  editor.config.toolbarStartupExpanded;
+							expanded =  editor.config.toolbarStartupExpanded,
+							groupStarted;
 
 						output.push( expanded ? '>' : ' style="display:none">' );
@@ -131,4 +132,10 @@
 								toolbarObj = { id : toolbarId, items : [] };
 
+							if ( groupStarted )
+							{
+								output.push( '</div>' );
+								groupStarted = 0;
+							}
+
 							if ( row === '/' )
 							{
@@ -137,5 +144,5 @@
 							}
 
-							output.push( '<div id="', toolbarId, '" class="cke_toolbar"><span class="cke_toolbar_start"></span>' );
+							output.push( '<span id="', toolbarId, '" class="cke_toolbar"><span class="cke_toolbar_start"></span>' );
 
 							// Add the toolbar to the "editor.toolbox.toolbars"
@@ -163,4 +170,18 @@
 								if ( item )
 								{
+									if ( item.canGroup )
+									{
+										if ( !groupStarted )
+										{
+											output.push( '<span class="cke_toolgroup">' );
+											groupStarted = 1;										
+										}
+									}
+									else if ( groupStarted )
+									{
+										output.push( '</span>' );
+										groupStarted = 0;										
+									}
+
 									var itemObj = item.render( editor, output );
 									index = toolbarObj.items.push( itemObj ) - 1;
@@ -187,5 +208,11 @@
 							}
 
-							output.push( '<span class="cke_toolbar_end"></span></div>' );
+							if ( groupStarted )
+							{
+								output.push( '</span>' );
+								groupStarted = 0;
+							}
+
+							output.push( '<span class="cke_toolbar_end"></span></span>' );
 						}
 
@@ -287,5 +314,5 @@
 CKEDITOR.config.toolbar_Basic =
 [
-	['Bold', 'Italic', '-', 'NumberedList', 'BulletedList', '-', 'Link', 'Unlink' ]
+	['Bold', 'Italic', '-', 'NumberedList', 'BulletedList', '-', 'Link', 'Unlink','-','About']
 ];
 
Index: CKEditor/trunk/_source/plugins/uicolor/dialogs/uicolor.js
===================================================================
--- CKEditor/trunk/_source/plugins/uicolor/dialogs/uicolor.js	(revision 3649)
+++ CKEditor/trunk/_source/plugins/uicolor/dialogs/uicolor.js	(revision 3649)
@@ -0,0 +1,200 @@
+/*
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.dialog.add( 'uicolor', function( editor )
+{
+	var dialog, picker, pickerContents,
+		// Actual UI color value.
+		uiColor = editor.getUiColor();
+	
+	function setNewPickerColor( color )
+	{
+		// Convert HEX representation to RGB, stripping # char.
+		if ( /^#/.test( color ) )
+			color = YAHOO.util.Color.hex2rgb( color.substr( 1 ) );
+		picker.setValue( color, true );
+		// Refresh picker UI.
+		picker.refresh( 'cke_uicolor_picker' );
+	};
+
+	function setNewUiColor( color, force )
+	{
+		if ( force || dialog._.contents.tab1.livePeview.getValue() )
+			editor.setUiColor( color );
+		// Write new config string into textbox.
+		dialog._.contents.tab1.configBox.setValue(
+			'config.uiColor = "#' + picker.get( "hex" ) + '"'
+		);
+	};
+
+	pickerContents =
+	{
+		id : 'yuiColorPicker',
+		type : 'html',
+		html : "<div id='cke_uicolor_picker' style='width: 360px; height: 200px; position: relative;'></div>",
+		onLoad : function( event )
+		{
+			var url = CKEDITOR.getUrl(
+					'_source/' + // %REMOVE_LINE%
+					'plugins/uicolor/yui/'
+				);
+
+			// Create new color picker widget.
+			picker = new YAHOO.widget.ColorPicker( "cke_uicolor_picker",
+				{
+					showhsvcontrols : true,
+					showhexcontrols : true,
+					images :
+					{
+						PICKER_THUMB : url + "assets/picker_thumb.png",
+						HUE_THUMB : url + "assets/hue_thumb.png"
+					}
+				});
+
+			// Set actual UI color to the picker.
+			if ( uiColor )
+				setNewPickerColor( uiColor );
+
+			// Subscribe to the rgbChange event.
+			picker.on( "rgbChange", function()
+				{
+					// Reset predefined box.
+					dialog._.contents.tab1.predefined.setValue( '' );
+					setNewUiColor( '#' + picker.get( 'hex' ) );
+				});
+
+			// Fix input class names.
+			var inputs = new CKEDITOR.dom.nodeList( picker.getElementsByTagName( 'input' ) );
+			for ( var i = 0; i < inputs.count() ; i++ )
+				inputs.getItem( i ).addClass( 'cke_dialog_ui_input_text' ); 
+		}
+	};
+
+	var skipPreviewChange = true;
+
+	return {
+		title : editor.lang.uicolor.title,
+		minWidth : 360,
+		minHeight : 320,
+		onLoad : function()
+		{
+			dialog = this;
+			this.setupContent();
+		},
+		contents : [
+			{
+				id : 'tab1',
+				label : '',
+				title : '',
+				expand : true,
+				padding : 0,
+				elements : [
+						pickerContents,
+						{
+							id : 'tab1',
+							type : 'vbox',
+							children :
+							[
+								{
+									id : 'livePeview',
+									type : 'checkbox',
+									label : editor.lang.uicolor.preview,
+									'default' : 1,
+									onLoad : function()
+									{
+										skipPreviewChange = true;
+									},
+									onChange : function()
+									{
+										if ( skipPreviewChange )
+											return;
+										var on = this.getValue(),
+											color = on ? '#' + picker.get( 'hex' ) : uiColor;
+										setNewUiColor( color, true );
+									}
+								},
+								{
+									type : 'hbox',
+									children :
+									[
+										{
+											id : 'predefined',
+											type : 'select',
+											'default' : '',
+											label : editor.lang.uicolor.predefined,
+											items :
+											[
+												[ '' ],
+												[ 'Light blue', '#9AB8F3' ],
+												[ 'Sand', '#D2B48C' ],
+												[ 'Metallic', '#949AAA', ],
+												[ 'Purple', '#C2A3C7' ],
+												[ 'Olive', '#A2C980' ],
+												[ 'Happy green', '#9BD446' ],
+												[ 'Jezebel Blue', '#14B8C4' ],
+												[ 'Burn', '#FF893A' ],
+												[ 'Easy red', '#FF6969' ],
+												[ 'Pisces 3', '#48B4F2' ],
+												[ 'Aquarius 5', '#487ED4' ],
+												[ 'Absinthe', '#A8CF76' ],
+												[ 'Scrambled Egg', '#C7A622' ],
+												[ 'Hello monday', '#8E8D80' ],
+												[ 'Lovely sunshine', '#F1E8B1' ],
+												[ 'Recycled air', '#B3C593' ],
+												[ 'Down', '#BCBCA4' ],
+												[ 'Mark Twain', '#CFE91D' ],
+												[ 'Specks of dust', '#D1B596' ],
+												[ 'Lollipop', '#F6CE23' ],
+											],
+											onChange : function()
+											{
+												var color = this.getValue();
+												if ( color )
+												{
+													setNewPickerColor( color );
+													setNewUiColor( color );
+													// Refresh predefined preview box.
+													CKEDITOR.document.getById( 'predefinedPreview' ).setStyle( 'background', color );
+												}
+												else
+													CKEDITOR.document.getById( 'predefinedPreview' ).setStyle( 'background', '' );
+											},
+											onShow : function()
+											{
+												var color = editor.getUiColor();
+												if ( color )
+													this.setValue( color );
+											}
+										},
+										{
+											id : 'predefinedPreview',
+											type : 'html',
+											html : '<div id="cke_uicolor_preview" style="border: 1px solid black; padding: 3px; width: 30px;">' +
+													'<div id="predefinedPreview" style="width: 30px; height: 30px;">&nbsp;</div>' +
+												'</div>'
+										}
+									]
+								},
+								{
+									id : 'configBox',
+									type : 'text',
+									label : editor.lang.uicolor.config,
+									onShow : function()
+									{
+										var color = editor.getUiColor();
+										if ( color )
+											this.setValue(
+												'config.uiColor = "' + color + '"'
+											);
+									}
+								}
+							]
+						},
+					]
+			}
+		],
+		buttons : [ CKEDITOR.dialog.okButton ]
+	};
+} );
Index: CKEditor/trunk/_source/plugins/uicolor/lang/en.js
===================================================================
--- CKEditor/trunk/_source/plugins/uicolor/lang/en.js	(revision 3649)
+++ CKEditor/trunk/_source/plugins/uicolor/lang/en.js	(revision 3649)
@@ -0,0 +1,15 @@
+/*
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.setLang( 'uicolor', 'en',
+{
+	uicolor :
+	{
+		title : 'UI Color Picker',
+		preview : 'Live preview',
+		config : 'Paste this string into your config.js file',
+		predefined : 'Predefined color sets'
+	}
+});
Index: CKEditor/trunk/_source/plugins/uicolor/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/uicolor/plugin.js	(revision 3649)
+++ CKEditor/trunk/_source/plugins/uicolor/plugin.js	(revision 3649)
@@ -0,0 +1,37 @@
+/*
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.add( 'uicolor',
+{
+	requires : [ 'dialog' ],
+	lang : [ 'en' ],
+
+	init : function( editor )
+	{
+		if ( CKEDITOR.env.ie6Compat )
+			return;
+		
+		editor.addCommand( 'uicolor', new CKEDITOR.dialogCommand( 'uicolor' ) );
+		editor.ui.addButton( 'UIColor',
+			{
+				label : editor.lang.uicolor.title,
+				command : 'uicolor',
+				icon : this.path + 'uicolor.gif'
+			});
+		CKEDITOR.dialog.add( 'uicolor', this.path + 'dialogs/uicolor.js' );
+
+		// Load YUI js files.
+		CKEDITOR.scriptLoader.load( CKEDITOR.getUrl(
+			'_source/' + // %REMOVE_LINE%
+			'plugins/uicolor/yui/yui.js'
+		));
+
+		// Load YUI css files.
+		editor.element.getDocument().appendStyleSheet( CKEDITOR.getUrl(
+				'_source/' + // %REMOVE_LINE%
+				'plugins/uicolor/yui/assets/yui.css'
+		));
+	}
+} );
Index: CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 3646)
+++ CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 3649)
@@ -202,7 +202,4 @@
 						if ( CKEDITOR.env.ie )
 						{
-							if ( CKEDITOR.env.version < 8 )
-								iframe.setStyle( 'position', 'absolute' );
-
 							if ( isCustomDomain )
 							{
Index: CKEditor/trunk/_source/skins/kama/skin.js
===================================================================
--- CKEditor/trunk/_source/skins/kama/skin.js	(revision 3649)
+++ CKEditor/trunk/_source/skins/kama/skin.js	(revision 3649)
@@ -0,0 +1,265 @@
+/*
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.skins.add( 'kama', (function()
+{
+	var preload = [];
+
+	if ( CKEDITOR.env.ie && CKEDITOR.env.version < 7 )
+	{
+		// For IE6, we need to preload some images, otherwhise they will be
+		// downloaded several times (CSS background bug).
+		preload.push( 'icons.png', 'images/sprites_ie6.png', 'images/dialog_sides.gif' );
+	}
+
+	return {
+		preload		: preload,
+		editor		: { css : [ 'editor.css' ] },
+		dialog		: { css : [ 'dialog.css' ] },
+		templates	: { css : [ 'templates.css' ] },
+		margins		: [ 0, 0, 0, 0 ],
+		init : function( editor )
+		{
+			var menuHead;
+			function menuSetUiColor( color )
+			{
+				if ( !menuHead )
+					return;
+
+				var uiStyle = menuHead.append('style');
+
+				var cssSrc = "/* UI Color Support */\
+.cke_skin_kama .cke_menuitem .cke_icon_wrapper\
+{\
+	background-color: $color !important;\
+	border-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a:hover .cke_icon_wrapper,\
+.cke_skin_kama .cke_menuitem a:focus .cke_icon_wrapper,\
+.cke_skin_kama .cke_menuitem a:active .cke_icon_wrapper\
+{\
+	background-color: $color !important;\
+	border-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a:hover .cke_label,\
+.cke_skin_kama .cke_menuitem a:focus .cke_label,\
+.cke_skin_kama .cke_menuitem a:active .cke_label\
+{\
+	background-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a.cke_disabled:hover .cke_label,\
+.cke_skin_kama .cke_menuitem a.cke_disabled:focus .cke_label,\
+.cke_skin_kama .cke_menuitem a.cke_disabled:active .cke_label\
+{\
+	background-color: transparent !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a.cke_disabled:hover .cke_icon_wrapper,\
+.cke_skin_kama .cke_menuitem a.cke_disabled:focus .cke_icon_wrapper,\
+.cke_skin_kama .cke_menuitem a.cke_disabled:active .cke_icon_wrapper\
+{\
+	background-color: $color !important;\
+	border-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a.cke_disabled .cke_icon_wrapper\
+{\
+	background-color: $color !important;\
+	border-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuseparator\
+{\
+	background-color: $color !important;\
+}\
+\
+.cke_skin_kama .cke_menuitem a:hover,\
+.cke_skin_kama .cke_menuitem a:focus,\
+.cke_skin_kama .cke_menuitem a:active\
+{\
+	background-color: $color !important;\
+}";
+
+				uiStyle.setAttribute( "type", "text/css" );
+				var regex = /\$color/g;
+
+				// We have to split CSS declarations for webkit.
+				if ( CKEDITOR.env.webkit )
+				{
+					cssSrc = cssSrc.split( '}' ).slice( 0, -1 );
+					for ( var i in cssSrc )
+							cssSrc[ i ] = cssSrc[ i ].split( '{' );
+				}
+
+				return ( menuSetUiColor =
+					function( color )
+					{
+						if ( CKEDITOR.env.webkit )
+						{
+							for ( var i in cssSrc )
+								uiStyle.$.sheet.addRule(
+									cssSrc[ i ][ 0 ], cssSrc[ i ][ 1 ].replace( regex, color )
+								);
+						}
+						else
+						{
+							var css = cssSrc.replace( regex, color );
+
+							if ( CKEDITOR.env.ie )
+								uiStyle.$.styleSheet.cssText = css;
+							else
+								uiStyle.setHtml( css );
+						}
+					})( color );
+			}
+
+			CKEDITOR.tools.extend( editor,
+			{
+				uiColor: null,
+
+				getUiColor : function()
+				{
+					return this.uiColor;
+				},
+
+				setUiColor : function( color )
+				{
+					var uiStyle = CKEDITOR.document.getHead().append('style'),
+						cssId = '#cke_' + editor.name.replace('.', '\\.');
+
+					var cssSelectors =
+						[
+							cssId + " .cke_wrapper",
+							cssId + "_dialog .cke_dialog_contents",
+							cssId + "_dialog a.cke_dialog_tab",
+							cssId + "_dialog .cke_dialog_footer"
+						].join( ',' );
+					var cssProperties = "background-color: $color !important;";
+
+					uiStyle.setAttribute("type", "text/css");
+
+					return ( this.setUiColor =
+						function( color )
+						{
+							var css = cssProperties.replace( '$color', color );
+							editor.uiColor = color;
+
+							if ( CKEDITOR.env.ie )
+								uiStyle.$.styleSheet.cssText = cssSelectors + '{' + css + '}';
+							else if ( CKEDITOR.env.webkit )
+								uiStyle.$.sheet.addRule( cssSelectors, css );
+							else
+								uiStyle.setHtml( cssSelectors + '{' + css + '}' );
+
+							menuSetUiColor( color );
+						})( color );
+				}
+			});
+
+			// If the "menu" plugin is loaded, register the listeners.
+			if ( CKEDITOR.menu )
+			{
+				var old = CKEDITOR.menu.prototype.show;
+				
+				CKEDITOR.menu.prototype.show = function()
+				{
+					old.apply( this, arguments );
+
+					if ( !menuHead && editor == this.editor )
+					{
+						// Save reference.
+						menuHead = this._.element.getDocument().getHead();
+						menuSetUiColor( editor.getUiColor() );
+					}
+				}
+			}
+
+			// Apply UI color if specified in config.
+			if ( editor.config.uiColor )
+				editor.setUiColor( editor.config.uiColor );
+
+			// Fix editor's width. HPadding and 100% width iframe issue.
+//			if ( CKEDITOR.env.ie && CKEDITOR.env.quirks )
+//			{
+//				editor.on( 'mode', function( event )
+//				{
+//					var container = editor.getResizable();
+//					editor.resize( container.$.offsetWidth-10, container.$.offsetHeight );
+//					event.removeListener();
+//				});
+//			}
+
+//			if ( CKEDITOR.env.ie && ( CKEDITOR.env.quirks || CKEDITOR.env.version < 7 ) )
+//			{
+//				editor.on( 'themeLoaded', function( event )
+//				{
+//					var toolbars = editor.container.getChild( [0, 0, 0, 0, 0, 0, 0] ).getChildren();
+//					for ( var i = 0 ; i < toolbars.count() ; i++ )
+//					{
+//						var toolbar = toolbars.getItem( i );
+
+//						var last = toolbar.getLast();
+//						if ( !last || !last.getPrevious().hasClass( 'cke_rcombo' ) )
+//							continue;
+//						
+//						last.addClass( 'cke_toolbar_end_last' );
+//					}
+//				});
+//			}
+		}
+	};
+})() );
+
+if ( CKEDITOR.dialog )
+{
+	CKEDITOR.dialog.on( 'resize', function( evt )
+		{
+			var data = evt.data,
+				width = data.width,
+				height = data.height,
+				dialog = data.dialog,
+				standardsMode = !CKEDITOR.env.quirks;
+
+			if ( data.skin != 'kama' )
+				return;
+
+			dialog.parts.contents.setStyles(
+				{
+					width : width + 'px',
+					height : height + 'px'
+				});
+
+			if ( !CKEDITOR.env.ie )
+				return;
+
+			// Fix the size of the elements which have flexible lengths.
+			setTimeout( function()
+				{
+					var content = dialog.parts.contents,
+						body = content.getParent(),
+						innerDialog = body.getParent();
+
+					// tc
+					var el = innerDialog.getChild( 2 );
+					el.setStyle( 'width', ( body.$.offsetWidth ) + 'px' );
+
+					// bc
+					el = innerDialog.getChild( 7 );
+					el.setStyle( 'width', ( body.$.offsetWidth - 28 ) + 'px' );
+
+					// ml
+					el = innerDialog.getChild( 4 );
+					el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+
+					// mr
+					el = innerDialog.getChild( 5 );
+					el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+				},
+				100 );
+		});
+}
Index: CKEditor/trunk/_source/themes/default/theme.js
===================================================================
--- CKEditor/trunk/_source/themes/default/theme.js	(revision 3646)
+++ CKEditor/trunk/_source/themes/default/theme.js	(revision 3649)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -38,13 +38,4 @@
 				width += 'px';
 
-			// Using a <div> as the outer element container can make IE goes crazy.
-			// The fact is that a <textarea> is an inline element. We aim to
-			// replace it with our structure, but <div> is a block element and it
-			// seems to be the cause of it. Using a <span>, which is inline just
-			// like <textarea>, makes it work.
-			// <table> is also a block element and should not go inside a <span>,
-			// not even in the places where <textarea> is valid. But this doesn't
-			// bring any evident problem as it seems that tables are treated
-			// differently by the browsers ("semi-inline").
 			var container = CKEDITOR.dom.element.createFromHtml( [
 				'<span' +
@@ -56,17 +47,19 @@
 					' lang="', editor.langCode, '"' +
 					' tabindex="' + tabIndex + '">' +
-				'<span class="' , CKEDITOR.env.cssClass, ' cke_', editor.lang.dir, '">' +
-					'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0" style="width:', width, '"><tbody>' +
-						'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top">'	, topHtml		, '</td></tr>' +
-						'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '">', contentsHtml, '</td></tr>' +
-						'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom">'	, bottomHtml	, '</td></tr>' +
-					'</tbody></table>' +
-					//Hide the container when loading skins, later restored by skin css.
-					'<style>.', editor.skinClass, '{visibility:hidden;}</style>' +
-				'</span>' +
+					'<span class="' , CKEDITOR.env.cssClass, '">' +
+						'<span class="cke_wrapper cke_', editor.lang.dir, '">' +
+							'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0" style="width:', width, '"><tbody>' +
+								'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top">'	, topHtml		, '</td></tr>' +
+								'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '">', contentsHtml, '</td></tr>' +
+								'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom">'	, bottomHtml	, '</td></tr>' +
+							'</tbody></table>' +
+							//Hide the container when loading skins, later restored by skin css.
+							'<style>.', editor.skinClass, '{visibility:hidden;}</style>' +
+						'</span>' +
+					'</span>' +
 				'</span>' ].join( '' ) );
 
-			container.getChild( [0, 0, 0, 0] ).unselectable();
-			container.getChild( [0, 0, 0, 2] ).unselectable();
+			container.getChild( [0, 0, 0, 0, 0] ).unselectable();
+			container.getChild( [0, 0, 0, 0, 2] ).unselectable();
 
 			if ( elementMode == CKEDITOR.ELEMENT_MODE_REPLACE )
@@ -94,5 +87,5 @@
 
 			var element = CKEDITOR.dom.element.createFromHtml( [
-					'<div class="cke_skin_', editor.skinName,
+					'<div id="cke_' + editor.name.replace('.', '\\.') + '_dialog" class="cke_skin_', editor.skinName,
 						'" dir="', editor.lang.dir, '"' +
 						' lang="', editor.langCode, '"' +
@@ -170,5 +163,5 @@
 };
 
-CKEDITOR.editor.prototype.resize = function( width, height, isContentHeight )
+CKEDITOR.editor.prototype.resize = function( width, height, isContentHeight, resizeInner )
 {
 	var numberRegex = /^\d+$/;
@@ -177,5 +170,6 @@
 
 	var contents = CKEDITOR.document.getById( 'cke_contents_' + this.name );
-	var outer = contents.getAscendant( 'table' );
+	var outer = resizeInner ? contents.getAscendant( 'table' ).getParent()
+		: contents.getAscendant( 'table' ).getParent().getParent().getParent();
 
 	// Resize the width first.
Index: CKEditor/trunk/ckeditor.pack
===================================================================
--- CKEditor/trunk/ckeditor.pack	(revision 3646)
+++ CKEditor/trunk/ckeditor.pack	(revision 3649)
@@ -52,4 +52,5 @@
 		'CKEDITOR.SELECTION_ELEMENT' : 3,
 		'CKEDITOR.UI_RICHCOMBO' : 3,
+		'CKEDITOR.UI_MENUBUTTON' : 5,
 		'CKEDITOR.DIALOG_RESIZE_NONE' : 0,
 		'CKEDITOR.DIALOG_RESIZE_WIDTH' : 1,
@@ -111,4 +112,5 @@
 					'_source/core/htmlparser/comment.js',
 					'_source/core/htmlparser/text.js',
+					'_source/core/htmlparser/cdata.js',
 					'_source/core/htmlparser/fragment.js',
 					'_source/core/htmlparser/element.js',
@@ -155,5 +157,7 @@
 					'_source/plugins/print/plugin.js',
 					'_source/plugins/removeformat/plugin.js',
+					'_source/plugins/resize/plugin.js',
 					'_source/plugins/save/plugin.js',
+					'_source/plugins/scayt/plugin.js',
 					'_source/plugins/smiley/plugin.js',
 					'_source/plugins/showblocks/plugin.js',
@@ -178,4 +182,5 @@
 					'_source/plugins/richcombo/plugin.js',
 					'_source/plugins/htmlwriter/plugin.js',
+					'_source/plugins/menubutton/plugin.js',
 					'_source/plugins/dialog/plugin.js',
 					'_source/plugins/editingblock/plugin.js',
@@ -183,5 +188,5 @@
 					'_source/plugins/listblock/plugin.js',
 					'_source/plugins/dialogui/plugin.js',
-					'_source/skins/v2/skin.js',
+					'_source/skins/kama/skin.js',
 					'_source/themes/default/theme.js'
 				]
